異常處理機制 ... cep super finally sta exc ace 避免

package com.swift;

public class Exception_TestC {

    public static void main(String[] args) {

        /*
         * 第5題: 有一個類為ClassA,有一個類為ClassB,在ClassB中有一個方法b,此方法拋出異常,在ClassA類中有一個
         * 方法a,請在這個方法中調用b,然後拋出異常。在客戶端有一個類為TestC,有一個方法為c ,請在這個方法中捕 捉異常的信息。Java異常的處理機制
         * 
         * 如果try或catch中有return,執行try catch finally return,catch的執行看try中是否真有異常 
         * throw是拋出異常 throws是聲明異常,throw用於方法體中,用來拋出一個實際的異常對象,使用throw後,要麽使用try
         * catch捕獲異常,要麽使用throws聲明異常 catch中可以再次throw拋出異常,以便調用其方法再次捕獲並處理
         * 自定義異常用於標記業務邏輯的異常,避免與標準異常混淆
         */
        new TestC().c();
    }
}

class A {

    public void a() throws Exception {

        new B().b();

    }

}

class B {

    public void b() {
        try {
            int a = -1;
            if (a < 0) {
                throw new MyException("B....不能使用負數..throw by ClassB.methodB");
            }
        } catch (MyException e) {
            e.printStackTrace();
        }
    }

}

class TestC{
    
    public void c() {

        try {
            new A().a();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}

class MyException extends Exception {
    public MyException(String msg) {
        super(msg);
    }
}

java中異常處理機制 throw拋出自定義業務邏輯異常 throws繼續拋出 catch捕獲後會自動繼續拋向調用方法